<?php
/**
 * $Horde$
 *
 * Copyright 2004-2005 Your Name <you@example.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('MOPPLE_BASE', dirname(__FILE__));
require_once MOPPLE_BASE . '/lib/base.php';
require_once MOPPLE_BASE . '/lib/MP3Form.php';
require_once 'Horde/Variables.php';

$variables = &Variables::getDefaultVariables();
$id = $variables->get('id');
$edit = !empty($id);
$title = $edit ? _("Edit MP3") : _("Add MP3");

$form = &new MP3_Form($variables, $title);

if ($form->validate($variables)) {
    /* The form was submitted and had valid data. */
    require_once MOPPLE_BASE . '/lib/Driver.php';
    $driver = &Mopple_Driver::singleton($conf['storage']['driver']);
    if ($edit) {
        $result = $driver->update($id,
                                  $variables->get('song_title'),
                                  $variables->get('song_artist'),
                                  $variables->get('song_album'));
    } else {
        $result = $driver->add($variables->get('song_title'),
                               $variables->get('song_artist'),
                               $variables->get('song_album'));
        $id = $result;
    }
    if (is_a($result, 'PEAR_Error')) {
        $notification->push($result, 'horde.error');
    } else {
        $message = $edit ? _("The MP3 \"%s\" has been updated sucessfully.") :
            _("The MP3 \"%s\" has been added successfully.");
        $notification->push(sprintf($message, $variables->get('song_title')), 'horde.success');

        /* Check for uploaded MP3 file. */
        $uploaded = Browser::wasFileUploaded('file');
        if (is_a($uploaded, 'PEAR_Error')) {
            if ($uploaded->getCode() != UPLOAD_ERR_NO_FILE) {
                $notification->push($uploaded, 'horde.warning');
            }
        } else {
            $form->getInfo($variables, $info);
            $tags = Mopple::addFile($id, $info['file']);
            if (is_a($tags, 'PEAR_Error')) {
                $notification->push(_("But there was an error with the uploaded file: ") . $tags->getMessage(), 'horde.warning');
            } else {
                $result = $driver->update($id,
                                          $variables->get('song_title'),
                                          $variables->get('song_artist'),
                                          $variables->get('song_album'),
                                          $tags);
            }
        }
        header('Location: ' . Horde::applicationUrl('list.php', true));
        exit;
    }
} elseif ($form->isSubmitted()) {
    /* The form was submitted but has invalid data. */
} elseif ($edit) {
    /* A certain MP3 was requested to edit. */
    require_once MOPPLE_BASE . '/lib/Driver.php';
    $driver = &Mopple_Driver::singleton($conf['storage']['driver']);
    $mp3 = $driver->get($id);
    foreach ($mp3 as $key => $value) {
        $variables->set($key, $value);
    }
}

require MOPPLE_TEMPLATES . '/common-header.inc';
require MOPPLE_TEMPLATES . '/menu.inc';
$renderer = &$form->getRenderer();
$form->renderActive($renderer, $variables, Horde::selfUrl(), 'post');
require $registry->get('templates', 'horde') . '/common-footer.inc';
